Index: tags/rel-1.6.0/zoo-project/zoo-kernel/Makefile.in
===================================================================
--- branches/branch-1.6/zoo-project/zoo-kernel/Makefile.in	(revision 807)
+++ tags/rel-1.6.0/zoo-project/zoo-kernel/Makefile.in	(revision 812)
@@ -61,4 +61,5 @@
 service_internal_ms.o: service_internal_ms.c
 	gcc ${JS_ENABLED} ${GDAL_CFLAGS}  ${JSCFLAGS} ${XML2CFLAGS} ${CFLAGS} -fPIC -c service_internal_ms.c
+	echo "SYMBOLSET\nEND" > sybols.sym
 
 service_internal_python.o: service_internal_python.c service.h
@@ -112,5 +113,5 @@
 	g++  ${XML2CFLAGS} ${CFLAGS} zcfg2yaml.o server_internal.o service_internal.o ${MS_FILE} response_print.o lex.cr.o lex.sr.o service_conf.tab.o main_conf_read.tab.o  ${YAML_FILE} -o zcfg2yaml -L. ${LDFLAGS}
 
-install:
+install: zoo_loader.cgi
 	install -d ${DESTDIR}${CGI_DIR}
 	install zoo_loader.cgi ${DESTDIR}${CGI_DIR}/
@@ -119,7 +120,8 @@
 	 if [ -e "libzoo_service.${EXT}" ]; then rm  libzoo_service.${EXT}; fi ; \
 	 ln -s ${LIBZOO_SERVICE} libzoo_service.${EXT})
+	if [ -z "${MS_FILE}" ] ; then echo "No symbols.sym" ; else install -d ${SHAREDSTATEDIR}; install symbols.sym ${SHAREDSTATEDIR}; fi
 	install -d ${DESTDIR}${INST_INCLUDE}/zoo
 	install sqlapi.h service.h service_internal.h ${DESTDIR}${INST_INCLUDE}/zoo
 
 clean:
-	rm -f version.h *.o *.zo *.eo *.tab.c *.tab.h *.sr.c* service_loader lex.* *.lreg *.sibling service_loader.dSYM *${EXT}
+	rm -f version.h symbols.sym *.o *.cgi *.eo *.tab.c *.tab.h *.sr.c* service_loader lex.* *.lreg *.sibling service_loader.dSYM *${EXT}
Index: tags/rel-1.6.0/zoo-project/zoo-kernel/ZOOMakefile.opts.in
===================================================================
--- branches/branch-1.6/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 807)
+++ tags/rel-1.6.0/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 812)
@@ -105,2 +105,3 @@
 
 DATAROOTDIR=@datarootdir@/zoo-project
+SHAREDSTATEDIR=@sharedstatedir@/zoo-project
Index: tags/rel-1.6.0/zoo-project/zoo-kernel/configure.ac
===================================================================
--- branches/branch-1.6/zoo-project/zoo-kernel/configure.ac	(revision 807)
+++ tags/rel-1.6.0/zoo-project/zoo-kernel/configure.ac	(revision 812)
@@ -595,4 +595,8 @@
 	[JDKHOME="$withval"; JAVA_ENABLED="-DUSE_JAVA"], [JAVA_ENABLED=""])
 
+AC_ARG_WITH([java-rpath], 
+	[AS_HELP_STRING([--with-java-rpath=yes], [To set rpath for java support, disabled by default])], 
+	[JAVA_RPATH="$withval"], [JAVA_RPATH=""])
+
 if test -z "$JAVA_ENABLED"
 then
@@ -621,11 +625,20 @@
 			JAVA_LDFLAGS="-L$JDKHOME/jre/lib/i386/server/ -ljvm -lpthread"
 			JAVA_CPPFLAGS="-I$JDKHOME/include -I$JDKHOME/include/linux"
+			if test x$JAVA_RPATH = "xyes"; then
+			   JAVA_LDFLAGS="$JAVA_LDFLAGS -Wl,-rpath,$JDKHOME/jre/lib/i386/server/"
+			fi
 		else
 			if test -d "$JDKHOME/jre/lib/amd64"; then
 			   JAVA_LDFLAGS="-L$JDKHOME/jre/lib/amd64/server/ -ljvm -lpthread"
 			   JAVA_CPPFLAGS="-I$JDKHOME/include -I$JDKHOME/include/linux"
+			   if test x$JAVA_RPATH = "xyes"; then
+			      JAVA_LDFLAGS="$JAVA_LDFLAGS -Wl,-rpath,$JDKHOME/jre/lib/amd64/server/"
+			   fi
 			else
 			   JAVA_LDFLAGS="-L$JDKHOME/jre/lib/server/ -ljvm -lpthread"
 			   JAVA_CPPFLAGS="-I$JDKHOME/include/ -I$JDKHOME/include/darwin"
+			   if test x$JAVA_RPATH = "xyes"; then
+			      JAVA_LDFLAGS="$JAVA_LDFLAGS -Wl,-rpath,$JDKHOME/jre/lib/server/"
+			   fi
 			fi
 		fi
Index: tags/rel-1.6.0/zoo-project/zoo-kernel/locale/po/it_IT.po
===================================================================
--- branches/branch-1.6/zoo-project/zoo-kernel/locale/po/it_IT.po	(revision 807)
+++ tags/rel-1.6.0/zoo-project/zoo-kernel/locale/po/it_IT.po	(revision 812)
@@ -4,5 +4,5 @@
 # 
 # Translators:
-# Luca Delucchi <lucadeluge@gmail.com>, 2015
+# Luca Delucchi <lucadeluge@gmail.com>, 2015,2017
 msgid ""
 msgstr ""
@@ -10,6 +10,6 @@
 "Report-Msgid-Bugs-To: zoo-discuss@lists.osgeo.org\n"
 "POT-Creation-Date: 2015-07-02 18:06+0200\n"
-"PO-Revision-Date: 2016-06-30 09:31+0000\n"
-"Last-Translator: Gérald FENOY <gerald.fenoy@geolabs.fr>\n"
+"PO-Revision-Date: 2017-01-25 07:49+0000\n"
+"Last-Translator: Luca Delucchi <lucadeluge@gmail.com>\n"
 "Language-Team: Italian (Italy) (http://www.transifex.com/zoo-project/zoo-kernel-internationalization/language/it_IT/)\n"
 "MIME-Version: 1.0\n"
@@ -199,5 +199,5 @@
 #: server_internal.c:1063
 msgid "Unable to open the registry directory."
-msgstr ""
+msgstr "Impossibile aprire la directory del registro"
 
 #: server_internal.c:1082
@@ -243,5 +243,5 @@
 "%s \n"
 " Unable to run your python process properly. Unable to provide any further information."
-msgstr ""
+msgstr "%s\nImpossibile eseguire il processo python correttamente. Impossible fornire nessun'altra informazione"
 
 #: zoo_service_loader.c:352
@@ -253,5 +253,5 @@
 #, c-format
 msgid "Error occurred while running the %s function: %s"
-msgstr ""
+msgstr "Errore accaduto durante l'esecuzione della funzione %s: %s"
 
 #: zoo_service_loader.c:578
@@ -277,5 +277,5 @@
 #: zoo_service_loader.c:895
 msgid "%s The following file: %s cannot be found."
-msgstr ""
+msgstr "%s il senguente file: %s non può essere trovato"
 
 #: zoo_service_loader.c:940
Index: tags/rel-1.6.0/zoo-project/zoo-kernel/main.cfg
===================================================================
--- branches/branch-1.6/zoo-project/zoo-kernel/main.cfg	(revision 807)
+++ 	(revision )
@@ -1,33 +1,0 @@
-[main]
-encoding = utf-8
-version = 1.0.0
-serverAddress = http://www.zoo-project.org/zoo/
-language = en-US
-lang = fr-FR,en-CA,en-US
-tmpPath=/tmp/
-tmpUrl = ../mpPathRelativeToServerAdress/
-dataPath = /tmp/
-cacheDir = /tmp/
-
-[identification]
-title = The Zoo WPS Development Server
-abstract = Development version of ZooWPS. See http://www.zoo-project.org
-fees = None
-accessConstraints = none
-keywords = WPS,GIS,buffer
-
-[provider]
-providerName=ZOO Project
-providerSite=http://www.zoo-project.org
-individualName=Gerald FENOY
-positionName=Developer
-role=Dev
-addressDeliveryPoint=1280, avenue des Platanes
-addressCity=Lattes
-addressAdministrativeArea=False
-addressPostalCode=34970
-addressCountry=fr
-addressElectronicMailAddress=gerald@geolabs.fr
-phoneVoice=False
-phoneFacsimile=False
-
Index: tags/rel-1.6.0/zoo-project/zoo-kernel/main.cfg.in
===================================================================
--- tags/rel-1.6.0/zoo-project/zoo-kernel/main.cfg.in	(revision 812)
+++ tags/rel-1.6.0/zoo-project/zoo-kernel/main.cfg.in	(revision 812)
@@ -0,0 +1,33 @@
+[main]
+encoding = utf-8
+version = 1.0.0
+serverAddress = http://www.zoo-project.org/zoo/
+language = en-US
+lang = fr-FR,en-CA,en-US
+tmpPath=/tmp/
+tmpUrl = ../tmpPathRelativeToServerAdress/
+dataPath = @sharedstatedir@/zoo-project
+cacheDir = /tmp/
+
+[identification]
+title = The Zoo WPS Development Server
+abstract = Development version of ZooWPS. See http://www.zoo-project.org
+fees = None
+accessConstraints = none
+keywords = WPS,GIS,buffer
+
+[provider]
+providerName=ZOO Project
+providerSite=http://www.zoo-project.org
+individualName=Gerald FENOY
+positionName=Developer
+role=Dev
+addressDeliveryPoint=1280, avenue des Platanes
+addressCity=Lattes
+addressAdministrativeArea=False
+addressPostalCode=34970
+addressCountry=fr
+addressElectronicMailAddress=gerald@geolabs.fr
+phoneVoice=False
+phoneFacsimile=False
+
Index: tags/rel-1.6.0/zoo-project/zoo-services/utils/status/Makefile
===================================================================
--- branches/branch-1.6/zoo-project/zoo-services/utils/status/Makefile	(revision 807)
+++ tags/rel-1.6.0/zoo-project/zoo-services/utils/status/Makefile	(revision 812)
@@ -8,5 +8,8 @@
 install:
 	install -d ${CGI_DIR}
-	install cgi-env/* ${CGI_DIR}/
+	install cgi-env/*.zcfg ${CGI_DIR}/
+	install cgi-env/*.zo ${CGI_DIR}/
+	install cgi-env/updateStatus.xsl ${SHAREDSTATEDIR}/
+
 clean:
 	rm -f cgi-env/wps_status.zo